
(ns clojureDemo.sys-utils

(:use [clojure.contrib duck-streams str-utils shell-out])
(:import java.io.File)
)



(defn rename [file]

  (if (re-matches #".*\.JPG$" (str file))
    (sh "mv" (str file)  (re-sub #"\.JPG" ".jpg" (str file)))
    nil))




(defn escape-spaces
  [string]
  (re-gsub #" " (str \-) string))


(defn view 
  [string]
  (seq (char-array string)))

(defn parent-source [target file]
  (File. (str target "/" (.getName (.getParentFile file))"-" (.getName file))))


(defn rsync [file1 file2]
  (let [*out* nil]
  (sh "rsync" "-avz" (str file1) (escape-spaces(str file2)))))

(defn shunt-file [target file]
  (rsync (str file) (str (parent-source target file)))) 
	
	  

(defn extract-files
  [regex source destination]

  (dorun (map (partial shunt-file destination) 
  (filter (comp not nil? (partial re-matches regex) str)  (file-seq source)))))


(defn file-count [#^java.io.File file]
  (count (file-seq file)))
  



(comment

(defn test-extract
  []
  ((partial extract-files #".*\.JPG"
	    (file-str " /home/r/Desktop/judy_yates_computer_archive/MyDocuments/dallas townhome") 
	    (file-str "/home/r/Desktop/judyates_admin/archive-source-images/"))))


(defn judy-jpg-extract
  []
  ((partial extract-files #".*\.JPG"
	    (file-str "/home/r/Desktop/judy_yates_computer_archive") 
	    (file-str "/home/r/Desktop/judyates_admin/archive-source-images/"))))

)
